// GreyShade
// tULAMIDE
// PS 2.0
// Color to greyscale conversion using luminance weights.

//#PARAM float lumWR 0.299 : Red Luminance Weight : The luminance weight of the red channel.
//#PARAM float lumWG 0.587 : Green Luminance Weight : The luminance weight of the green channel.
//#PARAM float lumWB 0.114 : Blue Luminance Weight : The luminance weight of the blue channel.
//#PARAM percent intensity 1 : Intensity : The intensity of the effect.
float lumWR;
float lumWG;
float lumWB;
float intensity;

// Foreground texture
texture ForegroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
};

// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{
    float4 color = tex2D(foreground, Tex);

    color.rgb /= color.a;
    float3 lumWeights = float3(lumWR,lumWG,lumWB);
    float lum = dot(color,lumWeights);
    color.rgb = lerp(color.rgb, lum, intensity);
    color.rgb *= color.a;

    return color;
}

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}