// Noise - static
// Pawel Brzozowski
// PS 2.0
// Adds static noise.



//#PARAM percent noiseInt 0.5 : Noise  : Intensity of noise.
//#PARAM float bgInt 100 : Background Intensity  : Background Intensity


float frameCounter; 
float noiseInt;
float bgInt;


// Foreground texture
texture ForegroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Point;
    MagFilter = Point;
    MipFilter = Point;
};

 
// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{
	 
	 float4 cTextureScreen = tex2D(foreground, Tex.xy);
	 float x = Tex.x * Tex.y * frameCounter *  1000;
	 x = fmod(x, 13) * fmod(x, 123);	
	 float dx = fmod(x, 0.01);
	 float3 cResult = (cTextureScreen.rgb*2) * saturate(0.1f + dx.xxx * bgInt);
	 cResult = lerp(cTextureScreen, cResult, saturate(noiseInt));
	 return float4(cResult, cTextureScreen.a);
} 

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}