// Radial Gradiant
// tULAMIDE
// PS 2.0
// Color gradiant.

//#PARAM float dir 0.0 : Direction : 1 = to outside, else = to inside

//#PARAM percent iRed 0.0 : Color1 Red : Amount in percent.
//#PARAM percent iGreen 0.0 : Color1 Green : Amount in percent.
//#PARAM percent iBlue 1.0 : Color1 Blue : Amount in percent.
//#PARAM percent iOpacity 1.0 : Color1 Opacity : Amount in percent.

//#PARAM percent oRed 1.0 : Color2 Red : Amount in percent.
//#PARAM percent oGreen 1.0 : Color2 Green : Amount in percent.
//#PARAM percent oBlue 1.0 : Color2 Blue : Amount in percent.
//#PARAM percent oOpacity 1.0 : Color2 Opacity : Amount in percent.

//#PARAM float opacity 1.0 : Opaque? : Set the regions outside the oval shape to 1 = opaque, else = transparent

float dir;
float iRed;
float iGreen;
float iBlue;
float iOpacity;
float oRed;
float oGreen;
float oBlue;
float oOpacity;
float opacity;

float boxLeft;
float boxTop;
float boxWidth;
float boxHeight;

// Foreground texture
texture ForegroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
};

// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{
    float lin;
    float2 coord = float2((Tex.x - boxLeft) / boxWidth, (Tex.y - boxTop) / boxHeight);
    float2 center = float2(0.5, 0.5);
    float dist = distance(coord, center) * 2;
    
    if(dir == 1)
        lin = dist;
    else
        lin = 1 - dist;

    float4 color = float4(0, 0, 0, 1);
    color.rgb = lerp(float3(iRed, iGreen, iBlue), float3(oRed, oGreen, oBlue), lin);
    color.a = lerp(iOpacity, oOpacity, lin);

    if(opacity != 1)
        if(dist > 1.0)
            color.a = 0;
    
    color.rgb *= color.a;
    return color;
}

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}